/*
 * spanel.java
 *
 * Created on 24. Mrz 2005, 01:01
 */
import java.util.Calendar;
import javax.swing.JTabbedPane;
import javax.swing.tree.*;

import org.apache.ws.pubsub.*;
import org.apache.ws.notification.topics.Topic;
/**
 *
 * @author  Administrator
 */
public class ConsumerPanel extends javax.swing.JPanel {
    private PubSubWSmanager pman;
    private Calendar time=Calendar.getInstance();
    
    private SubscriptionListModel sublistmodel;
    private NotificationListModel notlistmodel;
    /** Creates new form spanel */ 
    public ConsumerPanel(JTabbedPane notebook, PubSubWSmanager _pman) {
        this.pman=_pman;
        initComponents();
        timeSlider.setMinimum(0);
        timeSlider.setMaximum(100);
        timeSlider.setValue(0);

        sublistmodel=new SubscriptionListModel();
        notlistmodel=new NotificationListModel();
        subs.setModel(sublistmodel);
        nots.setModel(notlistmodel);

        DefaultTreeCellRenderer renderer2 = new DefaultTreeCellRenderer();
        renderer2.setOpenIcon(null);
        renderer2.setClosedIcon(null);
        renderer2.setLeafIcon(null);
        tree.setCellRenderer(renderer2);
            
        notebook.addTab( "Consumer", this );
        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        cXfilter = new javax.swing.JCheckBox();
        filterstr = new javax.swing.JTextField();
        cTermtime = new javax.swing.JCheckBox();
        termtime = new javax.swing.JTextField();
        cTfilter = new javax.swing.JCheckBox();
        jList1 = new javax.swing.JList();
        jButton1 = new javax.swing.JButton();
        cSubend = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new TopicSpaceTree(pman).getTree();

        jSeparator1 = new javax.swing.JSeparator();
        jScrollPane2 = new javax.swing.JScrollPane();
        subs = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        nots = new javax.swing.JList();
        renewButton = new javax.swing.JButton();
        unsubscribeButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        timeSlider = new javax.swing.JSlider();

        setLayout(null);

        cXfilter.setText("XPath Filter");
        cXfilter.setToolTipText("If you want to make a XPath Subscription click here");
        add(cXfilter);
        cXfilter.setBounds(10, 20, 93, 27);

        filterstr.setText("//a/b");
        filterstr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterstrActionPerformed(evt);
            }
        });

        add(filterstr);
        filterstr.setBounds(10, 50, 290, 24);

        cTermtime.setText("Termination Time");
        add(cTermtime);
        cTermtime.setBounds(10, 80, 130, 27);

        termtime.setText("jTextField2");
        termtime.setEnabled(false);
        add(termtime);
        termtime.setBounds(10, 110, 290, 24);

        cTfilter.setText("jCheckBox3");
        add(cTfilter);
        cTfilter.setBounds(340, 20, 150, 27);

        jList1.setBackground(new java.awt.Color(255, 51, 51));
        add(jList1);
        jList1.setBounds(70, 280, 0, 0);

        jButton1.setText("Subscribe");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                subscribeButton(evt);
            }
        });

        add(jButton1);
        jButton1.setBounds(10, 200, 290, 27);

        cSubend.setText("Subscription End Notification");
        add(cSubend);
        cSubend.setBounds(10, 170, 290, 27);

        jScrollPane1.setViewportView(tree);

        add(jScrollPane1);
        jScrollPane1.setBounds(340, 50, 200, 180);

        add(jSeparator1);
        jSeparator1.setBounds(10, 240, 530, 2);

        jScrollPane2.setViewportView(subs);

        add(jScrollPane2);
        jScrollPane2.setBounds(10, 270, 240, 110);

        jScrollPane3.setViewportView(nots);

        add(jScrollPane3);
        jScrollPane3.setBounds(280, 270, 260, 140);

        renewButton.setText("Renew");
        renewButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                renewButtonActionPerformed(evt);
            }
        });

        add(renewButton);
        renewButton.setBounds(10, 390, 80, 27);

        unsubscribeButton.setText("Unsubscribe");
        unsubscribeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                unsubscribeEvent(evt);
            }
        });

        add(unsubscribeButton);
        unsubscribeButton.setBounds(140, 390, 110, 27);

        jLabel1.setText("Subscriptions");
        add(jLabel1);
        jLabel1.setBounds(10, 250, 170, 18);

        jLabel2.setText("Notifications");
        add(jLabel2);
        jLabel2.setBounds(280, 250, 170, 18);

        timeSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                timeSliderHandler(evt);
            }
        });

        add(timeSlider);
        timeSlider.setBounds(10, 130, 290, 40);

    }//GEN-END:initComponents

    private void unsubscribeEvent(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_unsubscribeEvent
        if(subs.getSelectedIndex()!=-1){
            org.apache.ws.pubsub.Subscription s = (org.apache.ws.pubsub.Subscription)sublistmodel.getElementAt(subs.getSelectedIndex());
            s.unsubscribe();
        }
    }//GEN-LAST:event_unsubscribeEvent

    private void timeSliderHandler(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_timeSliderHandler
        time = Calendar.getInstance();
        time.add(Calendar.MINUTE,timeSlider.getValue());
        termtime.setText(time.getTime().toString());
    }//GEN-LAST:event_timeSliderHandler
    
    private void renewButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_renewButtonActionPerformed
        if(subs.getSelectedIndex()!=-1){
            org.apache.ws.pubsub.Subscription s = (org.apache.ws.pubsub.Subscription)sublistmodel.getElementAt(subs.getSelectedIndex());
            s.setTerminationTime(time);
        }
    }//GEN-LAST:event_renewButtonActionPerformed
    
    private void subscribeButton(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_subscribeButton
        Topic t=null;
        String xpath=null;
        Calendar expire=null;
        boolean subend = (cSubend.getSelectedObjects()!=null);
        if(cTfilter.getSelectedObjects()!=null){
            TreePath[] ts =tree.getSelectionModel().getSelectionPaths();
            if(ts!=null)
                t = (org.apache.ws.notification.topics.Topic)((DefaultMutableTreeNode) ts[ts.length-1].getLastPathComponent()).getUserObject();
        }
        if(cXfilter.getSelectedObjects()!=null){
            xpath= filterstr.getText();
        }
        if(cTermtime.getSelectedObjects()!=null){
                expire = time;
        }
        Subscription s = pman.subscribe(sublistmodel,notlistmodel,xpath,t, expire,subend);
        sublistmodel.addData(s);
    }//GEN-LAST:event_subscribeButton
    
    private void filterstrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterstrActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_filterstrActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox cSubend;
    private javax.swing.JCheckBox cTermtime;
    private javax.swing.JCheckBox cTfilter;
    private javax.swing.JCheckBox cXfilter;
    private javax.swing.JTextField filterstr;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JList nots;
    private javax.swing.JButton renewButton;
    private javax.swing.JList subs;
    private javax.swing.JTextField termtime;
    private javax.swing.JSlider timeSlider;
    private javax.swing.JTree tree;
    private javax.swing.JButton unsubscribeButton;
    // End of variables declaration//GEN-END:variables
    
}
