/*
 * Copyright 2001-2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.ws.eventing;
import org.apache.ws.addressing.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.apache.ws.pubsub.*;

import javax.xml.soap.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscriptionEndDocument;
import org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscriptionEndDocument.SubscriptionEnd;
import org.xmlsoap.schemas.ws.x2004.x08.eventing.LanguageSpecificStringType;

public class ForwardEndConsumer implements  org.apache.ws.pubsub.SubscriptionEndConsumer {
    private static final Log LOG = LogFactory.getLog( ForwardEndConsumer.class.getName() );

    public EndpointReference epr;
 
    
    public ForwardEndConsumer(EndpointReference epr){        
        this.epr=epr;          
    }
    
    public EndpointReference getEPR(){
        return this.epr;
    }

    public void setEPR( EndpointReference epr ){
        this.epr=epr;
    }

    public void end(org.apache.ws.pubsub.Subscription subscription, String reason){
        //TODO maybe unsubscribe myself
        if(epr==null){
            LOG.info("SubscriptionEnd without notification");
            return;
        }
        //send SubscriptionEnd Notification
        SubscriptionEndDocument sedom = SubscriptionEndDocument.Factory.newInstance();
        SubscriptionEndDocument.SubscriptionEnd se = sedom.addNewSubscriptionEnd();
        LanguageSpecificStringType reasont = se.addNewReason();
        reasont.setStringValue(reason);
        try{
            //now call 
            wsaSOAPConnection sconn = wsaSOAPConnection.newInstance();
            MessageFactory mf = MessageFactory.newInstance();
            SOAPMessage soapm = mf.createMessage();
            //put XMLbean into SOAPBody
            soapm.getSOAPBody().addDocument((org.w3c.dom.Document) sedom.newDomNode());

            sconn.call(soapm, epr);
        }catch(Exception e){
            e.printStackTrace();
        }        
    }
    
    
}
