/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ 
package org.apache.ws.eventing;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.ws.pubsub.Filter;
import org.apache.ws.resource.lifetime.ScheduledResourceTerminationResource;
import org.apache.ws.util.uuid.UuidGenerator;
import org.apache.ws.util.uuid.UuidGeneratorFactory;
import org.apache.ws.addressing.EndpointReference;

import java.util.Calendar;
/**
 *
 * @author  Stefan Lischke
 */
public class Subscription extends AbstractSubscription implements ScheduledResourceTerminationResource{
    private static final Log LOG = LogFactory.getLog( Subscription.class.getName() );
    
    private static final UuidGenerator UUID_GEN = UuidGeneratorFactory.createUUIdGenerator();
    private String QueryID;    
    private Filter m_filter;
    private java.net.URI m_delivery;
    public Subscription(Filter filter, Calendar expires, java.net.URI delivery){
        m_id = UUID_GEN.generateUuid();
        m_creationTime= Calendar.getInstance();
        m_filter = filter;
        setTerminationTime(expires);
        m_delivery=delivery;
    }  
    public Filter getFilter()throws Exception{
//        LOG.info("getFilterString : "+this.subdom.getSubscribe().getFilter().newCursor().getTextValue());
        return this.m_filter;
    }        
    public String getQueryID(){
        return QueryID;
    }
    public void setQueryID(String q){
        this.QueryID = q;
    }
    public void unsubscribe(){
        try{
            this.rH.remove(this.rK);
        }catch(Exception e){
            e.printStackTrace();
            //TODO
        }
        destroy();
    }
    
    public void destroy() {
        getSubscriptionEndConsumer().end(this,"killya");
        LOG.info("destroyed");
    }
    
    public void init() {
        LOG.info("init");
    }

    public void setTerminationTime(java.util.Calendar terminationTime) {
        LOG.info("Remote setTerminationTime "+terminationTime);
        m_terminationTime = terminationTime;        
    }
    
    public Calendar getCurrentTime()
    {
        return Calendar.getInstance();
    }

    public EndpointReference getEndpointReference()
    {
        return null; // TODO
    }
}
