/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.ws.eventing.porttype.impl;

import java.rmi.RemoteException;
import org.apache.ws.eventing.porttype.SubscriptionEndPortType;
import org.apache.ws.eventing.pubsub.Subscription;

import org.apache.ws.resource.properties.impl.AbstractResourcePropertiesPortType;
import org.apache.ws.resource.properties.NamespaceVersionHolder;

import org.apache.ws.resource.ResourceContext;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class SubscriptionEndPortTypeImpl extends AbstractResourcePropertiesPortType implements SubscriptionEndPortType{
    private static final Log LOG = LogFactory.getLog( SubscriptionEndPortTypeImpl.class.getName() );

    public SubscriptionEndPortTypeImpl( ResourceContext resourceContext )
    {        
        super( resourceContext );
    }
    
    public void subscriptionEnd(org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscriptionEndDocument body) throws RemoteException {
       Subscription subscription = (Subscription) getResource();
       subscription.getSubscriptionEndConsumer().end(subscription, body.getSubscriptionEnd().getReasonArray(0).getStringValue());
       LOG.info("subscriptionEnd");
       subscription.destroy();
    }

    protected NamespaceVersionHolder getNamespaceSet()
    {
        return null; // not currently used - will be needed once we need to support multiple spec versions
    }
}
