/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.ws.eventing.pubsub;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.ws.resource.JndiConstants;
import org.apache.ws.resource.impl.SimpleTypeResourceKey;

import javax.xml.namespace.QName;
/**
 *
 * @author  Stefan Lischke
 */
public class SubscriptionHome extends org.apache.ws.resource.impl.AbstractResourceHome /* implements org.apache.ws.resource.ResourceHome*/{
    /**  The service endpoint name as registered with the SOAP Platform.  This is useful for building EPR's. **/
    public static final javax.xml.namespace.QName SERVICE_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/notification/base/service/SubscriptionEndPort}SubscriptionEndPort");


    /** The management PortType associated with this resource. This is useful for building EPR's.**/
    public static final javax.xml.namespace.QName PORT_TYPE = javax.xml.namespace.QName.valueOf("http://ws.apache.org/notification/base/service/SubscriptionEndPort}SubscriptionEndPortPortType");

    /** The WSDL Port name associated with the resource. This is useful for building EPR's. **/
    public static final String PORT_NAME = "SubscriptionEndPort";

    /** The name of the resource key for this resource. **/
    public static final javax.xml.namespace.QName RESOURCE_KEY_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/notification/base/service/SubscriptionEndPort}ResourceID");


    //private static Map m_resources=new java.util.HashMap(); 
    
    public static final String HOME_LOCATION = JndiConstants.CONTEXT_NAME_SERVICES + "/" + SERVICE_NAME.getLocalPart() + "/" + JndiConstants.ATOMIC_NAME_HOME;
    private static int num=0;
    private static final Log LOG = LogFactory.getLog( SubscriptionHome.class.getName() );

    public void SubscriptionHome(){
        num++;
        LOG.info("create SubscriptionHome number : "+num);
    }
    
    
    public Subscription create(){        
        Subscription s = new Subscription(); 
        SimpleTypeResourceKey resourceKey = new SimpleTypeResourceKey( QName.valueOf( getResourceKeyName()), (String) s.getID());
        s.setResourceKey(resourceKey);
        s.setResourceHome(this);
        LOG.info("before add "+ m_resources.size()+" instance "+this);        
        add(resourceKey,s);
    //    m_resources.put(resourceKey,s);
        
        LOG.info("after add "+ m_resources.size());        
        return s;
    }
    
    public org.apache.ws.resource.Resource getInstance(org.apache.ws.resource.ResourceContext resourceContext) throws org.apache.ws.resource.ResourceException, org.apache.ws.resource.ResourceContextException, org.apache.ws.resource.ResourceUnknownException {
        LOG.info("getInstance "+ m_resources.size()+" SubscriptionHome : "+resourceContext.getResourceKey().getValue()+ " instance "+this);
        return find( resourceContext.getResourceKey() );
    }   
    /*
    public org.apache.ws.resource.Resource find(org.apache.ws.resource.ResourceKey key) throws org.apache.ws.resource.ResourceException, org.apache.ws.resource.NoSuchResourceException, org.apache.ws.resource.InvalidResourceKeyException {
        return((org.apache.ws.resource.Resource)m_resources.get(key));
    }
     */
    /*
    public String getResourceClassName() {
    }
    
    public String getResourceKeyClassName() {
    }
    
    public String getResourceKeyName() {
    }
    
    public String getServiceClassName() {
    }
    
    public String getWsdlTargetNamespace() {
    }*/
    
    public void remove(org.apache.ws.resource.ResourceKey key) throws org.apache.ws.resource.ResourceException,  org.apache.ws.resource.InvalidResourceKeyException, org.apache.ws.resource.RemoveNotSupportedException {
    }           //todo I removed org.apache.ws.resource.NoSuchResourceException, from signature above to be able to compile
    /*
    public void setResourceClassName(String className) {
    }
    
    public void setResourceKeyClassName(String className) {
    }
    
    public void setResourceKeyName(String keyName) {
    }
    
    public void setServiceClassName(String className) {
    }
    
    public void setWsdlTargetNamespace(String targetNamespace) {
    }
    */
    public QName getServiceName()
    {
        return SERVICE_NAME;
    }

    public QName getPortType()
    {
        return PORT_TYPE;
    }

    public String getServicePortName()
    {
        return PORT_NAME;
    }

    public QName getResourceKeyNameQName()
    {
        return RESOURCE_KEY_NAME;
    }
}
