/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.ws.eventing.services;

import org.apache.ws.eventing.services.AbstractService;
import org.apache.ws.resource.ResourceContext;

import org.apache.ws.eventing.porttype.*;
import org.apache.ws.eventing.porttype.impl.*;
 
public class BrokerService extends AbstractService implements SubscriptionEndPortType, NotificationPortType,EventSourcePortType, SubscriptionManagerPortType {

    public BrokerService(){
    }
    public BrokerService(ResourceContext resourceContext)
   {
      m_resourceContext = resourceContext;
      init();
   }
    public org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscribeResponseDocument subscribe(org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscribeDocument body) throws java.rmi.RemoteException {
        return new EventSourcePortTypeImpl(/*getResourceContext()*/).subscribe(body);
    }
    
    public org.xmlsoap.schemas.ws.x2004.x08.eventing.GetStatusResponseDocument getStatus(org.xmlsoap.schemas.ws.x2004.x08.eventing.GetStatusDocument body) throws java.rmi.RemoteException {
        return new SubscriptionManagerPortTypeImpl(getResourceContext()).getStatus(body);
    }

    public org.xmlsoap.schemas.ws.x2004.x08.eventing.RenewResponseDocument renew(org.xmlsoap.schemas.ws.x2004.x08.eventing.RenewDocument body) throws java.rmi.RemoteException {
        return new SubscriptionManagerPortTypeImpl(getResourceContext()).renew(body);
    }

    
    public void unsubscribe(org.xmlsoap.schemas.ws.x2004.x08.eventing.UnsubscribeDocument body) throws java.rmi.RemoteException {
        new SubscriptionManagerPortTypeImpl(getResourceContext()).unsubscribe(body); 
    }
    
    public void subscriptionEnd(org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscriptionEndDocument body) throws java.rmi.RemoteException {
        new SubscriptionEndPortTypeImpl(getResourceContext()).subscriptionEnd(body);
    }    
    
    public void filter(org.apache.axis.message.SOAPEnvelope req, org.apache.axis.message.SOAPEnvelope resp) {
        new SimpleNotificationPortTypeImpl().filter(req, resp);
    }    
    
}
