/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.ws.eventing.services;

import org.apache.ws.eventing.services.AbstractService;
import org.apache.ws.resource.ResourceContext;

import org.apache.ws.eventing.porttype.EventSourcePortType;
import org.apache.ws.eventing.porttype.impl.EventSourcePortTypeImpl;

import org.apache.ws.eventing.porttype.SubscriptionManagerPortType;
import org.apache.ws.eventing.porttype.impl.SubscriptionManagerPortTypeImpl;

public class PublisherService extends AbstractService implements  EventSourcePortType, SubscriptionManagerPortType {
    
   public PublisherService( ResourceContext resourceContext )
   {
      m_resourceContext = resourceContext;
      init();
   }
      
    
    public org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscribeResponseDocument subscribe(org.xmlsoap.schemas.ws.x2004.x08.eventing.SubscribeDocument body) throws java.rmi.RemoteException {
        return new EventSourcePortTypeImpl(/*getResourceContext()*/).subscribe(body);
    }
    
    public org.xmlsoap.schemas.ws.x2004.x08.eventing.GetStatusResponseDocument getStatus(org.xmlsoap.schemas.ws.x2004.x08.eventing.GetStatusDocument body) throws java.rmi.RemoteException {
        return new SubscriptionManagerPortTypeImpl(getResourceContext()).getStatus(body);
    }

    public org.xmlsoap.schemas.ws.x2004.x08.eventing.RenewResponseDocument renew(org.xmlsoap.schemas.ws.x2004.x08.eventing.RenewDocument body) throws java.rmi.RemoteException {
        return new SubscriptionManagerPortTypeImpl(getResourceContext()).renew(body);
    }

    
    public void unsubscribe(org.xmlsoap.schemas.ws.x2004.x08.eventing.UnsubscribeDocument body) throws java.rmi.RemoteException {
        new SubscriptionManagerPortTypeImpl(getResourceContext()).unsubscribe(body); 
    }
    
}
