package org.apache.ws.notification.base.faults;

import org.apache.ws.notification.base.WsnNamespaceVersionHolder;
import org.apache.ws.notification.base.v2004_06.BaseNotificationConstants;
import org.apache.ws.resource.faults.AbstractBaseFaultException;

import javax.xml.namespace.QName;

/**
 * The WS-BaseN NoCurrentMessageOnTopicFault (thrown by GetCurrentMessage operation).
 */
public class NoCurrentMessageOnTopicFaultException extends AbstractBaseFaultException
{
    private QName m_name;

    public NoCurrentMessageOnTopicFaultException(WsnNamespaceVersionHolder namespaceVersionHolder)
    {
        super(namespaceVersionHolder, "The specified Topic is supported, but there is no notification message currently available on it.");
        m_name = new QName( namespaceVersionHolder.getBaseNotificationXsdNamespace(), "NoCurrentMessageOnTopicFault", BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );
    }

    public QName getBaseFaultName()
    {
        return m_name;
    }
}
