package org.apache.ws.notification.base.faults;

import org.apache.ws.notification.base.WsnNamespaceVersionHolder;
import org.apache.ws.notification.base.v2004_06.BaseNotificationConstants;
import org.apache.ws.resource.faults.AbstractBaseFaultException;

import javax.xml.namespace.QName;

/**
 * The WS-BaseN PauseFailedFault (thrown by Pause operation).
 */
public class PauseFailedFaultException extends AbstractBaseFaultException
{
    private QName m_name;

    public PauseFailedFaultException( WsnNamespaceVersionHolder namespaceVersionHolder, String faultString )
    {
        super( namespaceVersionHolder, faultString );
        m_name =
                new QName( namespaceVersionHolder.getBaseNotificationXsdNamespace(), "PauseFailedFault",
                        BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );
    }

    public QName getBaseFaultName()
    {
        return m_name;
    }
}
