package org.apache.ws.notification.base.faults;

import org.apache.ws.notification.base.WsnNamespaceVersionHolder;
import org.apache.ws.notification.base.v2004_06.BaseNotificationConstants;
import org.apache.ws.resource.faults.AbstractBaseFaultException;

import javax.xml.namespace.QName;

/**
 * The WS-BaseN SubscribeCreationFailedFault (thrown by Subscribe operation).
 */
public class SubscribeCreationFailedFaultException extends AbstractBaseFaultException
{
    private QName m_name;

    public SubscribeCreationFailedFaultException(WsnNamespaceVersionHolder namespaceVersionHolder)
    {
        super(namespaceVersionHolder, "Unable to create subscription due to internal server error.");
        m_name = new QName( namespaceVersionHolder.getBaseNotificationXsdNamespace(), "SubscribeCreationFailedFault", BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );
    }

    public QName getBaseFaultName()
    {
        return m_name;
    }
}
