package org.apache.ws.notification.base.faults;

import org.apache.ws.notification.base.WsnNamespaceVersionHolder;
import org.apache.ws.notification.base.v2004_06.BaseNotificationConstants;
import org.apache.ws.resource.faults.AbstractBaseFaultException;

import javax.xml.namespace.QName;

/**
 * The WS-BaseN TopicNotSupportedFault (thrown by GetCurrentMessage operation).
 */
public class TopicNotSupportedFaultException extends AbstractBaseFaultException
{
    private QName m_name;

    public TopicNotSupportedFaultException(WsnNamespaceVersionHolder namespaceVersionHolder, String faultString)
    {
        super(namespaceVersionHolder, faultString);
        m_name = new QName( namespaceVersionHolder.getBaseNotificationXsdNamespace(), "TopicNotSupportedFault", BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );
    }

    public QName getBaseFaultName()
    {
        return m_name;
    }
}
