/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.base.v2004_06.porttype;

import org.apache.ws.notification.base.v2004_06.BaseNotificationConstants;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.PauseSubscriptionDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.PauseSubscriptionResponseDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.ResumeSubscriptionDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.ResumeSubscriptionResponseDocument;

import javax.xml.namespace.QName;

/**
 * The WS-BaseNotification SubscriptionManager portType.
 */
public interface SubscriptionManagerPortType
{

    QName NAME = new QName( BaseNotificationConstants.NSURI_WSNT_WSDL, "SubscriptionManager",
            BaseNotificationConstants.NSPREFIX_WSNT_WSDL );
    QName PROPS_DOC_NAME = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA, "SubscriptionManagerRP",
            BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * ConsumerReference property name.
     */
    QName PROP_QNAME_CONSUMER_REFERENCE = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA,
            "ConsumerReference", BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * TopicExpression property name.
     */
    QName PROP_QNAME_TOPIC_EXPRESSION = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA, "TopicExpression",
            BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * UseNotify property name.
     */
    QName PROP_QNAME_USE_NOTIFY = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA, "UseNotify",
            BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * Precondition property name.
     */
    QName PROP_QNAME_PRECONDITION = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA, "Precondition",
            BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * Selector property name.
     */
    QName PROP_QNAME_SELECTOR = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA, "Selector",
            BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * SubscriptionPolicy property name.
     */
    QName PROP_QNAME_SUBSCRIPTION_POLICY = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA,
            "SubscriptionPolicy", BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * CreationTime property name.
     */
    QName PROP_QNAME_CREATION_TIME = new QName( BaseNotificationConstants.NSURI_WSNT_SCHEMA, "CreationTime",
            BaseNotificationConstants.NSPREFIX_WSNT_SCHEMA );

    /**
     * @param requestDoc
     *
     * @return
     */
    PauseSubscriptionResponseDocument pauseSubscription( PauseSubscriptionDocument requestDoc );

    /**
     * @param requestDoc
     *
     * @return
     */
    ResumeSubscriptionResponseDocument resumeSubscription( ResumeSubscriptionDocument requestDoc );

}
