/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/

package org.apache.ws.notification.pubsub;
import org.apache.ws.notification.base.impl.AbstractSubscription;
import org.xmlsoap.schemas.ws.x2003.x03.addressing.EndpointReferenceType;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.SubscribeResponseDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.SubscribeResponseDocument.SubscribeResponse;
import org.apache.ws.addressing.XmlBeansEndpointReference;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.apache.ws.util.uuid.UuidGenerator;
import org.apache.ws.util.uuid.UuidGeneratorFactory;
import org.apache.ws.pubsub.SubscriptionEndConsumer;

import java.util.Calendar;
/**
 *
 * @author  Stefan Lischke
 */
public class Subscription extends AbstractSubscription{
    private EndpointReferenceType sMan; 
    private static final Log LOG = LogFactory.getLog( Subscriber.class.getName() );
    
    private static final UuidGenerator UUID_GEN = UuidGeneratorFactory.createUUIdGenerator();

    
    /** Creates a new instance of Subscription */
    public Subscription() {
        m_id = UUID_GEN.generateUuid();
        m_creationTime= Calendar.getInstance();        
    }

    public void setSubscriptionManager(SubscribeResponseDocument.SubscribeResponse sresdom) {
        sMan = sresdom.getSubscriptionReference();
        super.setEndpointReference(new XmlBeansEndpointReference(sMan));
    }
 
    public void init() {
    }
    public void setResourcePropertySet(org.apache.ws.resource.properties.ResourcePropertySet propSet){
        
    }

    /**
     * Get the subscriptionEnd consumer associated with this subscription.
     *
     * @return the subscriptionEnd consumer
     */
    public SubscriptionEndConsumer getSubscriptionEndConsumer()
    {
        return null;   //todo
    }
}
