/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.expression;

import java.net.URI;

/**
 * Java representation of the wsnt:TopicExpressionType XML schema type.
 *
 * @author Ian Springer (ian DOT springer AT hp DOT com)
 */
public interface TopicExpression
{

    /**
     * Returns the dialect of this topic expression.
     */
    URI getDialect();

    /**
     * Returns the content of this topic expression (typically a String).
     */
    Object getContent();

    /**
     * Returns a namespace context that can be used to resolve prefixes within this
     * query expression's content.
     */
    Object getNamespaceContext();

}
