/*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.apache.ws.notification.topics.expression;



/**
 * This exception is raised if the given topic expression dialect is
 * unsupported.
 */
public class TopicPathDialectUnknownException
    extends TopicExpressionException
{
    /**
     * Creates a UnsupportedQueryDialectException without error message.
     */
    public TopicPathDialectUnknownException()
    {
    }

    /**
     * Creates a UnsupportedQueryDialectException with a given error message.
     *
     * @param message error message
     */
    public TopicPathDialectUnknownException(String message)
    {
        super(message);
    }

    /**
     * Creates a UnsupportedQueryDialectException with a given error message
     * and nested exception.
     *
     * @param message error message
     * @param exception nested exception/
     */
    public TopicPathDialectUnknownException(
        String message,
        Throwable exception)
    {
        super(message, exception);
    }

    /**
     * Creates a UnsupportedQueryDialectException from a nested exception.
     *
     * @param exception nested exception
     */
    public TopicPathDialectUnknownException(Throwable exception)
    {
        super(exception);
    }
}
