/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.impl;

import org.apache.ws.notification.topics.ResourcePropertyValueChangeTopic;
import org.apache.ws.resource.properties.ResourceProperty;
import org.apache.ws.resource.properties.ResourcePropertyValueChangeEvent;
import org.apache.ws.XmlObjectWrapper;

/**
 * TODO
 */
public class ResourcePropertyValueChangeTopicImpl extends TopicImpl implements ResourcePropertyValueChangeTopic
{
    private ResourceProperty m_prop;

    public ResourcePropertyValueChangeTopicImpl( ResourceProperty prop )
    {
        super( prop.getMetaData().getName().getLocalPart() );
        m_prop = prop;
    }

    public ResourceProperty getResourceProperty()
    {
        return m_prop;
    }

    public void propertyChanged( ResourcePropertyValueChangeEvent event )
    {
        Object msg;
        if ( event instanceof XmlObjectWrapper )
        {
            msg = ((XmlObjectWrapper)event).getXmlObject();
        }
        else
        {
            msg = event;
        }
        try
        {
            publish( msg );
        }
        catch ( Exception e )
        {
            // TODO: do we want to throw this and cause the SetRP request to fault?
            e.printStackTrace();
        }
    }

}
