package org.apache.ws.notification.topics.impl;

import org.apache.ws.resource.lifetime.ResourceTerminationEvent;
import org.apache.ws.resource.lifetime.ResourceTerminationListener;
import org.apache.ws.resource.lifetime.impl.ResourceTerminationEventImpl;
import org.apache.ws.resource.properties.NamespaceVersionHolder;

/**
 * @author Sal Campana
 */
public class ResourceTerminationTopicImpl extends TopicImpl implements ResourceTerminationListener
{
    private static final String TOPIC_NAME = "ResourceTermination";

    /**
     * This provides the version of the topic we are dealing with for use when creating the notification.
     */
    private NamespaceVersionHolder m_namespaceSet;

    /**
     * Create a resource termination topic for the given WSRF namespace set.
     */
    public ResourceTerminationTopicImpl( NamespaceVersionHolder namespaceSet )
    {
        super( TOPIC_NAME );
        m_namespaceSet = namespaceSet;
    }

    public void terminationOccurred( ResourceTerminationEvent event )
    {
        Object msg = ( (ResourceTerminationEventImpl) event ).getTerminationNotifDocXmlBean( m_namespaceSet );
        try
        {
            publish( msg );
        }
        catch ( Exception e )
        {
            // TODO: do we want to throw this and cause the SetRP request to fault?
            e.printStackTrace();
        }
    }
}
