/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.impl;

import org.apache.ws.notification.topics.Topic;
import org.apache.ws.notification.topics.TopicListener;
import org.apache.ws.notification.topics.TopicSpace;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * TODO
 */
public class TopicSpaceImpl implements TopicSpace
{

    private String m_targetNs;
    private String m_name = "TopicSpace";
    private Map m_rootTopicMap = new HashMap();

    public TopicSpaceImpl( String targetNs )
    {
        m_targetNs = targetNs != null ? targetNs : "";
    }

    public String getTargetNamespace()
    {
        return m_targetNs;
    }

    public String getName()
    {
        return m_name;
    }

    public void setName( String name )
    {
        m_name = name;
    }

    public Topic addTopic( Topic topic )
    {
        m_rootTopicMap.put( topic.getName(), topic );
        topic.setTopicSpace(this);
        return topic;
    }

    public Topic addTopic( String name ) throws Exception
    {
        return addTopic( new TopicImpl( name ) );
    }

    public void removeTopic( String name )
    {
        m_rootTopicMap.remove( name );
    }

    public Topic getTopic( String name )
    {
        return (Topic) m_rootTopicMap.get( name );
    }

    public boolean containsTopic( String name )
    {
        return m_rootTopicMap.containsKey( name );
    }

    public Iterator topicIterator()
    {
        return m_rootTopicMap.values().iterator();
    }

    public void addTopicListener( TopicListener listener )
    {
        // TODO: either remove, or implement
    }

    public void removeTopicListener( TopicListener listener )
    {
        // TODO: either remove, or implement
    }

    public Iterator topicListenerIterator()
    {
        return null;  // TODO: either remove, or implement
    }

}
