/*
 * TopicSpaceParser.java
 *
 * Created on 1. Mrz 2005, 12:54
 */

package org.apache.ws.notification.topics.util;
import org.apache.ws.notification.topics.*;
import org.apache.ws.notification.topics.impl.TopicSpaceImpl;
import org.apache.ws.notification.topics.impl.TopicImpl;
import java.io.InputStream;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
/**
 *
 * @author  Stefan Lischke
 */
public class TopicSpaceParser extends DefaultHandler{
    private static TopicSpace m_topicSpace;
    private static java.util.Stack stack;
    private int depth=0;
    private String tns;
    
    public static TopicSpace parse(InputStream is){
        // Use an instance of ourselves as the SAX event handler
        DefaultHandler handler = new TopicSpaceParser();
        // Parse the input with the default (non-validating) parser
        stack= new java.util.Stack();
        try{
            SAXParser saxParser = SAXParserFactory.newInstance().newSAXParser();
            //System.out.println("start parsing");
            saxParser.parse( is, handler );
            //System.out.println("end parsing");
            
        }catch(Exception e){
            e.printStackTrace();
        }
        return m_topicSpace;
    }
    
    public void startElement( String namespaceURI,
    String localName,   // local name
    String qName,       // qualified name
    Attributes attrs ) throws SAXException {
        try{
            //System.out.println("start element "+qName);
            if(qName.endsWith("topicSpace")){
                tns=attrs.getValue("targetNamespace");
                m_topicSpace=new TopicSpaceImpl(tns);
                //System.out.println("topicspace "+tns);
            }
            if(qName.endsWith("topic")){
                Topic t=new TopicImpl(attrs.getValue("name"));
                if(depth==0){
                    m_topicSpace.addTopic(t);
                    stack.push(t);
                }else{
                    Topic in = (Topic)stack.peek();
                    in.addTopic(t);
                    stack.push(t);
                }
                //System.out.println(depth+" : "+attrs.getValue("name"));
                depth++;
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public void endElement( String namespaceURI,
    String localName,     // local name
    String qName )        // qualified name
    throws SAXException {
        if(qName.endsWith("topic")){
            if(depth>0){
                depth--;
                stack.pop();
            }
            
        }
    }
}