/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.ws.pubsub;

import java.net.URI;
import org.w3c.dom.Node;
/**
 *
 * @author  Stefan Lischke
 */
public abstract class AbstractFilter implements Filter{
    private Node m_content;
    private URI m_dialect;
    
    public AbstractFilter() {
        m_content=null;
        m_dialect=null;
    }    
    
    public AbstractFilter(Node content) {
        m_content=content;
        m_dialect=null;
    }
    public AbstractFilter(Node content, URI dialect) {
        m_content=content;
        m_dialect=dialect;
    }
    
    public java.net.URI getURI(){
        return m_dialect;
    }
    public void setURI(String uri){
        try{
            this.m_dialect  = new URI(uri); 
        }catch(java.net.URISyntaxException e){
            //TODO
            e.printStackTrace();
        }
    }
    public void setURI(URI uri){ 
        this.m_dialect  = uri;
    }    
    public Object getExpression(){
        return m_content.getNodeValue();
    }
    public void setContent(Node n){
        this.m_content=n;
    }
    
}
