/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.pubsub.emitter;


/**
 * An exception thrown by a notification emitter indicating a problem when
 * attempting to send a notification to a subscriber.
 */
public class EmitterException
   extends Exception
{
   /**
    * Constructor for {@link EmitterException}.
    */
   public EmitterException(  )
   {
      super(  );
   }

   /**
    * Constructor for {@link EmitterException}.
    *
    * @param message
    */
   public EmitterException( String message )
   {
      super( message );
   }

   /**
    * Constructor for {@link EmitterException}.
    *
    * @param message
    * @param cause
    */
   public EmitterException( String    message,
                            Throwable cause )
   {
      super( message, cause );
   }

   /**
    * Constructor for {@link EmitterException}.
    *
    * @param cause
    */
   public EmitterException( Throwable cause )
   {
      super( cause );
   }
}