/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.pubsub.i18n;

import org.apache.ws.util.i18n.AbstractMessages;
import org.apache.ws.util.i18n.Messages;

/**
 * Singleton used by all classes below the {@link org.apache.ws.pubsub} package
 * for retrieving i18n messages.
 *
 * @author Ian P. Springer
 */
public class MessagesImpl
   extends AbstractMessages
{
   /** the package name of the project */
   public static final String PROJECT_PACKAGE_NAME = "org.apache.ws.pubsub";

   /** package where the i18n stuff can be found */
   public static final String RESOURCE_PACKAGE_NAME = "org.apache.ws.pubsub.i18n";
   private static Messages    s_ourInstance = new MessagesImpl(  );

   /**
    * Returns this singleton.
    *
    * @return the singleton
    */
   public static Messages getInstance(  )
   {
      return s_ourInstance;
   }

   /**
    * Returns the project's package name.
    *
    * @return project package name
    */
   protected String getProjectPackageName(  )
   {
      return PROJECT_PACKAGE_NAME;
   }

   /**
    * Returns the package name where the i18n stuff can be found.
    *
    * @return resource package name
    */
   protected String getResourcePackageName(  )
   {
      return RESOURCE_PACKAGE_NAME;
   }
}