/*
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.ws.pubsub;

/**
 *
 * @author  Stefan Lischke
 */
import org.apache.ws.addressing.EndpointReference;
import javax.xml.soap.*;
import org.apache.xmlbeans.XmlObject;
import org.apache.xmlbeans.XmlCursor;
import javax.xml.namespace.QName;

public class wsaSOAPConnection {
    
    /** Creates a new instance of wsaSOAPConnection */
    public wsaSOAPConnection() {
    }
    
    /**
     * @return The unique instance of this class.
     */
    
    static public wsaSOAPConnection newInstance() {
       return new wsaSOAPConnection();
    }
    
    public SOAPMessage call(SOAPMessage request, String url ) throws SOAPException{       
        SOAPConnectionFactory sconF= SOAPConnectionFactory.newInstance();
        SOAPConnection scon = sconF.createConnection();
        return(scon.call(request, url));
    }
    public SOAPMessage call(SOAPMessage request,EndpointReference epr) throws SOAPException{
        SOAPHeader sH = request.getSOAPHeader();
        //if epr contains ReferenceProperty add WSA header
        XmlObject[] refprops = (XmlObject[])epr.getReferenceProperties(); 
        if(refprops!=null){
            for(int i=0;i<refprops.length;i++){
                XmlCursor xc = refprops[i].newCursor();
                QName propname = xc.getName(); 
                sH.addChildElement(propname.getLocalPart(),propname.getPrefix(),propname.getNamespaceURI()).addTextNode(xc.getTextValue()); 
                xc.dispose();
            }
        }
        return(call(request,epr.getAddress()));
    }
}
