package org.apache.ws.notification.base.impl;

import org.apache.ws.addressing.EndpointReference;
import org.apache.ws.notification.base.NotificationProducerResource;
import org.apache.ws.notification.topics.impl.TopicSpaceImpl;
import org.apache.ws.resource.PropertiesResource;
import org.apache.ws.resource.lifetime.ResourceTerminationListener;
import org.apache.ws.resource.properties.ResourcePropertySet;
import org.apache.ws.resource.properties.impl.XmlBeansResourcePropertySet;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.NotificationProducerRPDocument;

/**
 * @author Sal Campana
 */
public class UnitResource  implements PropertiesResource, NotificationProducerResource
{
    ResourcePropertySet m_resourcePropertySet;
    private EndpointReference m_epr;
    private Object m_id;
    public static final String TOPIC_NAME = "test";
    org.apache.ws.notification.topics.TopicSpaceSet m_topicSpaceSet = new org.apache.ws.notification.topics.impl.TopicSpaceSetImpl(true);

    public UnitResource()
    {

    }

    public ResourcePropertySet getResourcePropertySet()
    {
        return m_resourcePropertySet;
    }

    public void setResourcePropertySet(ResourcePropertySet resourcePropertySet)
    {
         m_resourcePropertySet = resourcePropertySet;
    }

    public void setID(Object o)
    {
        m_id = o;
    }

    public Object getID()
    {
        return m_id;
    }

    public void destroy()
    {

    }

    public void init()
    {
        NotificationProducerRPDocument notificationProducerRPDocument = NotificationProducerRPDocument.Factory.newInstance();
        NotificationProducerRPDocument.NotificationProducerRP notificationProducerRP = notificationProducerRPDocument.addNewNotificationProducerRP();
        m_resourcePropertySet = new XmlBeansResourcePropertySet(notificationProducerRPDocument);

        TopicSpaceImpl topicSpace = new TopicSpaceImpl(UnitExampleHome.TARGET_NAMESPACE);


        try
        {
            topicSpace.addTopic(TOPIC_NAME);
            getTopicSpaceSet().addTopicSpace(topicSpace);
            org.apache.ws.notification.topics.util.TopicUtils.addResourcePropertyValueChangeTopics(getResourcePropertySet(), getTopicSpaceSet());
        }
        catch (Exception e)
        {
            throw new javax.xml.rpc.JAXRPCException("Unable to init the ResourceProperty Changed topics. Cause: " + e.getLocalizedMessage(), e);
        }

        org.apache.ws.notification.topics.util.TopicUtils.initNotificationProducerProperties(getTopicSpaceSet(), getResourcePropertySet());
    }

    public void addTerminationListener(ResourceTerminationListener resourceTerminationListener)
    {

    }

    public EndpointReference getEndpointReference()
    {
        return m_epr;
    }

   public void setEndpointReference(EndpointReference epr)
    {
        m_epr = epr;
    }

    public org.apache.ws.notification.topics.TopicSpaceSet getTopicSpaceSet()
    {
        return m_topicSpaceSet;
    }

}
