package org.apache.ws.notification.topics;

import org.apache.ws.pubsub.NotificationProducer;
import org.apache.ws.pubsub.Filter;
import org.apache.ws.pubsub.Subscription;
import org.apache.ws.pubsub.NotificationConsumer;
import org.apache.ws.pubsub.DeliveryMode;
import org.apache.ws.pubsub.SubscriptionEndConsumer;
import org.apache.ws.pubsub.TopicFilter;
import org.apache.ws.pubsub.XPathFilter;
import org.apache.ws.addressing.EndpointReference;
import org.apache.ws.addressing.XmlBeansEndpointReference;
import org.xmlsoap.schemas.ws.x2003.x03.addressing.EndpointReferenceType;
import org.xmlsoap.schemas.ws.x2003.x03.addressing.AttributedURI;

import java.util.Calendar;
import java.util.StringTokenizer;


/**
 * @author Sal Campana
 */
public class NotifProducer implements NotificationProducer
{


    /**
     * Returns this producer's endpoint reference.
     *
     * @return this producer's endpoint reference
     */
    public EndpointReference getEPR()
    {
        EndpointReferenceType epr = EndpointReferenceType.Factory.newInstance();
        AttributedURI attributedURI = AttributedURI.Factory.newInstance();
        attributedURI.setStringValue("http://foo");
        epr.setAddress(attributedURI);
        return new XmlBeansEndpointReference(epr);
    }

    /**
     * Subscribe to notifications from this producer.
     *
     * @param notificationConsumer
     * @param subscriptionEndConsumer the callback Interface for SubscriptionEnd Notifications, or null if no SubscriptionEnd should be send
     * @param filters
     * @param initialTerminationTime
     * @param deliveryMode            the notification delivery mode, or null to use default mode
     * @return the subscription
     */
    public Subscription subscribe(NotificationConsumer notificationConsumer, SubscriptionEndConsumer subscriptionEndConsumer, TopicFilter tf, XPathFilter xf, Calendar initialTerminationTime, boolean UseNotify)
    {
        return null;  //todo implement
    }

    /**
     * Subscribe to notifications from this producer.
     *
     * @param notificationConsumer
     * @param filters
     * @param initialTerminationTime
     * @param deliveryMode           the notification delivery mode, or null to use default mode
     * @param policy                 a policy to be associated with the subscription, or null if no policy should be used
     * @return the subscription
     */
    public Subscription subscribe(NotificationConsumer notificationConsumer, Filter filters[], Calendar initialTerminationTime, DeliveryMode deliveryMode, Object policy)
    {
        return null;
    }

    /**
     * Returns the last notification message published for the given set of filters.
     *
     * @param filters
     * @return
     */
    public Object getCurrentMessage(Filter filters[])
    {
        return null;
    }

    public static void main( String[] args )
    {
        StringTokenizer tok = new StringTokenizer( " / " );
        while ( tok.hasMoreElements() )
        {
            System.out.println( "[" + tok.nextElement() + "]" );
        }
    }

}
